Index: trunk/testcase/emxomf-long-symbols.c
===================================================================
--- trunk/testcase/emxomf-long-symbols.c	(revision 2430)
+++ trunk/testcase/emxomf-long-symbols.c	(revision 2430)
@@ -0,0 +1,74 @@
+//
+int a____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_______240_______250_______260_______270_______280_______290_______300_______310_______320_______330_______340_______350_______360_______370_______380_______390_______400;
+int b____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_______240_______250_______260_______270_______280_______290_______300_______310_______320_______330_______340_______350_______360_______370_______380_______390_______400 __attribute__((weak));
+
+int c____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_______240_______250__;
+int d____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_______240_______250__ __attribute__((weak));
+
+int e____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_______;
+int f____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_______ __attribute__((weak));
+
+int g____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230______;
+int h____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230______ __attribute__((weak));
+
+int i____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_____;
+int j____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_____ __attribute__((weak));
+
+int k____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230____;
+int l____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230____ __attribute__((weak));
+
+int m____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230___;
+int n____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230___ __attribute__((weak));
+
+int o____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230__;
+int q____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230__ __attribute__((weak));
+
+int r____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_;
+int s____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230_ __attribute__((weak));
+
+int t____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230;
+int u____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______230 __attribute__((weak));
+
+int v____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______23;
+int w____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______23 __attribute__((weak));
+
+int x____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______2;
+int y____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______2 __attribute__((weak));
+
+int z____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______;
+int A____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_______ __attribute__((weak));
+
+int B____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220______;
+int C____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220______ __attribute__((weak));
+
+int D____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_____;
+int E____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_____ __attribute__((weak));
+
+int F____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220____;
+int G____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220____ __attribute__((weak));
+
+int H____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220___;
+int I____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220___ __attribute__((weak));
+
+int J____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220__;
+int K____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220__ __attribute__((weak));
+
+int L____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_;
+int M____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220_ __attribute__((weak));
+
+int N____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220;
+int O____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______220 __attribute__((weak));
+
+int P____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______22;
+int Q____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______22 __attribute__((weak));
+
+int R____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______2;
+int S____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______2 __attribute__((weak));
+
+int T____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______;
+int U____5____10___15___20___25___30___35___40________50________60________70________80________90________100__5____110_______120_______130_______140_______150_______160_______170_______180_______190_______200_______210_______ __attribute__((weak));
+
+int main()
+{
+    return 0;
+}